import static org.junit.Assert.*;

import org.junit.Test;

public class TestGenericSLL {
	@Test
	public void testChainOfNodesApproach1() {
		Node<String> tom = new Node<>("Tom", null);
		Node<String> mark = new Node<>("Mark", tom);
		Node<String> alan = new Node<>("Alan", mark);
		
		assertTrue(alan.getNext() == mark);
		assertTrue(mark.getNext() == tom);
		assertTrue(alan.getNext().getNext() == tom);
		assertTrue(tom.getNext() == null);
		assertTrue(mark.getNext().getNext() == null);
		assertTrue(alan.getNext().getNext().getNext() == null);
		
		assertEquals("Alan", alan.getElement());
		assertEquals("Mark", mark.getElement());
		assertEquals("Mark", alan.getNext().getElement());
		assertEquals("Tom", tom.getElement());
		assertEquals("Tom", mark.getNext().getElement());
		assertEquals("Tom", alan.getNext().getNext().getElement());
	}
	
	@Test
	public void testChainOfNodesApproach2() {
		Node<String> alan = new Node<>("Alan", null);
		Node<String> mark = new Node<>("Mark", null);
		Node<String> tom = new Node<>("Tom", null);
		alan.setNext(mark);
		mark.setNext(tom);
		
		assertTrue(alan.getNext() == mark);
		assertTrue(mark.getNext() == tom);
		assertTrue(alan.getNext().getNext() == tom);
		assertTrue(tom.getNext() == null);
		assertTrue(mark.getNext().getNext() == null);
		assertTrue(alan.getNext().getNext().getNext() == null);
		
		assertEquals("Alan", alan.getElement());
		assertEquals("Mark", mark.getElement());
		assertEquals("Mark", alan.getNext().getElement());
		assertEquals("Tom", tom.getElement());
		assertEquals("Tom", mark.getNext().getElement());
		assertEquals("Tom", alan.getNext().getNext().getElement());
	}
	
	@Test
	public void testSLL() {
		SinglyLinkedList<String> list = new SinglyLinkedList<>();
		list.addFirst("Tom");
		list.addFirst("Mark");
		list.addFirst("Alan");
		assertEquals("Alan", list.getNodeAt(0).getElement());
		assertEquals("Mark", list.getNodeAt(1).getElement());
		assertEquals("Tom", list.getNodeAt(2).getElement());
	}
}
